import 'package:flutter_dynamic_ui/component/base_block.dart';
import 'package:flutter_dynamic_ui/component/base_card.dart';

abstract class Registry<Type, DynamicComponent> {
  Map<Type, DynamicComponent> getMap();
}

abstract class CardRegistry extends Registry<String, BaseCard> {
  @override
  Map<String, BaseCard> getMap();
}

abstract class BlockRegistry extends Registry<String, BaseBlock> {
  @override
  Map<String, BaseBlock> getMap();
}
