import 'package:json_annotation/json_annotation.dart';

part 'data_model.g.dart';

@JsonSerializable()
class PageData {
  String id;

  @JsonKey(name: "cards")
  List<CardData> cardList;

  Map<String, dynamic> extras;

  PageData({this.id, this.cardList, this.extras});

  factory PageData.fromJson(Map<String, dynamic> json) =>
      _$PageDataFromJson(json);
  Map<String, dynamic> toJson() => _$PageDataToJson(this);

  @override
  String toString() {
    return 'Page{id: $id, cardList: $cardList, extras: $extras}';
  }
}

@JsonSerializable()
class CardData {
  String id;
  String type;
  @JsonKey(name: "blocks")
  List<BlockData> blockList;

  Map<String, dynamic> extras;

  CardData({this.id, this.type, this.blockList, this.extras});
  factory CardData.fromJson(Map<String, dynamic> json) =>
      _$CardDataFromJson(json);
  Map<String, dynamic> toJson() => _$CardDataToJson(this);

  @override
  String toString() {
    return 'Card{id: $id, type: $type, blockList: $blockList, extras: $extras}';
  }
}

@JsonSerializable()
class BlockData {
  String id;
  String type;
  Map<String, dynamic> extras;

  BlockData({this.id, this.type, this.extras});

  factory BlockData.fromJson(Map<String, dynamic> json) =>
      _$BlockDataFromJson(json);
  Map<String, dynamic> toJson() => _$BlockDataToJson(this);

  @override
  String toString() {
    return 'Block{id: $id, type: $type, extras: $extras}';
  }
}

@JsonSerializable()
class Meta {
  String text;
  Meta({this.text});

  factory Meta.fromJson(Map<String, dynamic> json) => _$MetaFromJson(json);
  Map<String, dynamic> toJson() => _$MetaToJson(this);

  @override
  String toString() {
    return 'Meta{text: $text}';
  }
}

@JsonSerializable()
class Btn {
  String text;

  Btn({this.text});
  factory Btn.fromJson(Map<String, dynamic> json) => _$BtnFromJson(json);
  Map<String, dynamic> toJson() => _$BtnToJson(this);

  @override
  String toString() {
    return 'Btn{text: $text}';
  }
}

@JsonSerializable()
class Img {
  String url;

  Img({this.url});

  factory Img.fromJson(Map<String, dynamic> json) => _$ImgFromJson(json);
  Map<String, dynamic> toJson() => _$ImgToJson(this);

  @override
  String toString() {
    return 'Img{url: $url}';
  }
}

@JsonSerializable()
class Custom {
  Custom();
  factory Custom.fromJson(Map<String, dynamic> json) => _$CustomFromJson(json);
  Map<String, dynamic> toJson() => _$CustomToJson(this);
}
