import 'dart:convert';

import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';
import 'package:flutter_dynamic_ui/api/parser.dart';
import 'package:flutter_dynamic_ui/model/data_model.dart';

class AssetParser implements DataParser {
  @override
  Future<PageData> parse(String filename) {
    return rootBundle.loadStructuredData<PageData>(
        filename, (value) => _parser(value));
  }

  Future<PageData> _parser(String value) async {
    final Map<String, dynamic> jsonMap = jsonDecode(value);
    final page = PageData.fromJson(jsonMap);
    return SynchronousFuture(page);
  }
}
